#include <sys/types.h>
#include <utime.h>
#include <time.h>
#include <stdio.h>

/* int utime(const char *filename, struct utimbuf *buf); */

setfiletime(const char *filename, short dosdate, short dostime) {
	struct tm ddt; struct utimbuf utb;
#if 0
struct tm {
	int	tm_sec;		/* seconds */
	int	tm_min;		/* minutes */
	int	tm_hour;	/* hours */
	int	tm_mday;	/* day of the month */
	int	tm_mon;		/* month */
	int	tm_year;	/* year */
	int	tm_wday;	/* day of the week */
	int	tm_yday;	/* day in the year */
	int	tm_isdst;	/* daylight saving time */
};
#endif
	ddt.tm_sec=	(dostime<<1)	&0x3f;
	ddt.tm_min=	(dostime>>5)	&0x3f;
	ddt.tm_hour=	(dostime>>11)	&0x1f;
	ddt.tm_mday=	dosdate		&0x1f;
	ddt.tm_mon=	((dosdate>>5)	&0xf)-1;
	ddt.tm_year=	((dosdate>>9)	&0x7f)+80;
	ddt.tm_isdst=	0;
/*	fprintf(stderr,"%04u/%02u/%02u %2u:%02u:%02u = ",
		ddt.tm_year+1900,ddt.tm_mon,ddt.tm_mday,
		ddt.tm_hour,ddt.tm_min,ddt.tm_sec);	*/
	utb.actime=0; utb.modtime=mktime(&ddt);
	if(ddt.tm_isdst>0) utb.modtime-=3600;
/*	fprintf(stderr,"%s",ctime(&utb.modtime));	*/
	return utime(filename,&utb);
}
